// Look for identity results

#include <stdlib.h>
#include <string.h>
#include <assert_ops/libc.h>
#include <bestiola/err_wrap.h>

#include "hash_vector.h"
#include "require.h"

int main(void) {
	REQUIRE_FEEDBACK;

	unsigned char in[BYTES];
	unsigned char out[BYTES];

	size_t count = 0;
	size_t END = (size_t) 1 << BITS;
	size_t size = 0;
	for (; size < END; size++) {
		unsigned i = 0;
		for (; i < BYTES; i++)
			in[i] = size >> 8 * i;
		hash_vector(out, in);
		if (!memcmp(out, in, BYTES)) {
			assert_printf("%zx\n", size);
			count++;
		}
	}

	if (count)
		errx_fail("Failed! %zu", count);

	assert_puts("Passed");
	return EXIT_SUCCESS;
}
