// Calculate recursively and test whether block 0 appears

#include <stdlib.h>
#include <string.h>
#include <assert_ops/libc.h>
#include <bestiola/err_wrap.h>

#include "hash_vector.h"
#include "require.h"

static void hash_block(unsigned char out[BYTES], unsigned char hvin[BYTES]);

int main(void) {
	REQUIRE_MIX_PREVIOUS;

	unsigned char needle[BYTES];
	unsigned char out[BYTES];

	memset(needle, 0, sizeof needle);
	memset(out, 0, sizeof out);

	unsigned char hvin[BYTES];
	hash_vector(hvin, out);

	size_t END = (size_t) 1 << 32;
	size_t size = 0;
	for (; size < END; size++) {
		hash_block(out, hvin);
		if (!memcmp(out, needle, BYTES))
			errx_fail("Failed!");
	}

	unsigned i;
	for (i = 0; i < BYTES; i++)
		assert_printf("%02x", out[i]);

	assert_puts("\nPassed");
	return EXIT_SUCCESS;
}

static void hash_block(unsigned char out[BYTES], unsigned char hvin[BYTES]) {
	unsigned char hvout[BYTES];
	hash_vector(hvout, out);
	unsigned i = 0;
	for (; i < BYTES; i++)
		out[i] = hvin[i] ^ hvout[(i + BYTES / 2) % BYTES];
}
