// Calculate recursively and test whether later block appears

#include <stdlib.h>
#include <string.h>
#include <assert_ops/libc.h>
#include <bestiola/assert.h>
#include <bestiola/err_wrap.h>

#include "hash_vector.h"
#include "require.h"

static void hash_block(unsigned char out[BYTES], unsigned char hvin[BYTES]);

int main(void) {
	REQUIRE_MIX_PREVIOUS;

	// Result from test_block_0
	unsigned char needle[] = {0xc6, 0x56, 0x21, 0x75, 0xd8, 0x1b, 0xdc,
		0x4d, 0xfb, 0xa0, 0x15, 0xe4, 0xd7, 0x35, 0x89, 0xe3, 0xdc,
		0x08, 0xf0, 0xce, 0x1c, 0xab, 0x55, 0x56, 0x89, 0xe9, 0x20,
		0xc2, 0xb0, 0x5e, 0x9d, 0x0b};
	if (sizeof needle != BYTES)
		bad_assertion();

	unsigned char out[BYTES];
	memset(out, 0, sizeof out);

	unsigned char hvin[BYTES];
	hash_vector(hvin, out);

	size_t END = (size_t) 1 << 32;
	size_t size = 0;
	for (; size < END; size++) {
		hash_block(out, hvin);
		if (!memcmp(out, needle, BYTES))
			break;
	}

	if (size < END - 1)
		errx_fail("Failed!");
	if (size > END - 1)
		errx_fail("Wrong initial value!");

	assert_puts("Passed");
	return EXIT_SUCCESS;
}

static void hash_block(unsigned char out[BYTES], unsigned char hvin[BYTES]) {
	unsigned char hvout[BYTES];
	hash_vector(hvout, out);
	unsigned i = 0;
	for (; i < BYTES; i++)
		out[i] = hvin[i] ^ hvout[(i + BYTES / 2) % BYTES];
}
