// Calculate recursively and test whether vector 0 appears

#include <stdlib.h>
#include <string.h>
#include <assert_ops/libc.h>
#include <bestiola/err_wrap.h>

#include "hash_vector.h"
#include "require.h"

static void hash_block(unsigned char b[BYTES]);

int main(void) {
	REQUIRE_FEEDBACK;

	unsigned char needle[BYTES];
	unsigned char out[BYTES];

	memset(needle, 0, sizeof needle);
	memset(out, 0, sizeof out);

	size_t END = (size_t) 1 << 32;
	size_t size = 0;
	for (; size < END; size++) {
		hash_block(out);
		if (!memcmp(out, needle, BYTES))
			errx_fail("Failed!");
	}

	unsigned i = 0;
	for (; i < BYTES; i++)
		assert_printf("%02x", out[i]);

	assert_puts("\nPassed");
	return EXIT_SUCCESS;
}

static void hash_block(unsigned char b[BYTES]) {
	unsigned char hvb[BYTES];
	hash_vector(hvb, b);
	memcpy(b, hvb, BYTES);
}
