// Calculate recursively and test whether later vector appears

#include <stdlib.h>
#include <string.h>
#include <assert_ops/libc.h>
#include <bestiola/assert.h>
#include <bestiola/err_wrap.h>

#include "hash_vector.h"
#include "require.h"

static void hash_block(unsigned char b[BYTES]);

int main(void) {
	REQUIRE_FEEDBACK;

	// Result from test_vector_0
	unsigned char needle[] = {0xf0, 0xbc, 0x3c, 0x57, 0x0a, 0xc7, 0x49,
		0x1d, 0x1b, 0x3b, 0x72, 0xbf, 0xd0, 0x7f, 0xe6, 0xb1, 0x2a,
		0xf2, 0x26, 0x38, 0xa1, 0x67, 0x33, 0x2f, 0x85, 0xfd, 0xa1,
		0x61, 0xbc, 0x5d, 0xf5, 0x7c};
	if (sizeof needle != BYTES)
		bad_assertion();

	unsigned char out[BYTES];
	memset(out, 0, sizeof out);

	size_t END = (size_t) 1 << 32;
	size_t size = 0;
	for (; size < END; size++) {
		hash_block(out);
		if (!memcmp(out, needle, BYTES))
			break;
	}

	if (size < END - 1)
		errx_fail("Failed!");
	if (size > END - 1)
		errx_fail("Wrong initial value!");

	assert_puts("Passed");
	return EXIT_SUCCESS;
}

static void hash_block(unsigned char b[BYTES]) {
	unsigned char hvb[BYTES];
	hash_vector(hvb, b);
	memcpy(b, hvb, BYTES);
}
